//++++ Looks like this is mostly my code, and is likely well-tested: Sekar
//Checked with nBMSL, lifted some code from there that looked cleaner, 
// while retaining other code from here.

#include "ParserUtil.h"
#include "Error.h"

static int variableCount = 1;
int yycolumnno;

static void 
errPrint(ErrorST code, const string& sym) {
  switch (code) {
  case DUPLICATE_SYM:
	errMsgLn("Redefinition of name " + sym);
	break;
  case SYM_NOT_PRESENT:
	errMsgLn("Undeclared symbol `" + sym + "'");
	break;
  case INVALID_SCOPE:
	errMsgLn("Definition of `" + sym +"' is invalid in " + 
		   stm.currentScope()->name());
	break;
  default:
	break;
  }
}

ErrorST insertSymbolErrCheck(SymTabEntry* se) {
  ErrorST err = stm.insert(se);
  errPrint(err, se->name());
  return err;
}

void enterScopeErrCheck(SymTabEntry* se) {
  errPrint(stm.enterScope(se), se->name());
}

void enterNameSpaceErrCheck(SymTabEntry* se) {
  errPrint(stm.enterNameSpace(se), se->name());
} 

void leaveScopeErrCheck() {
  if (stm.leaveScope() != OK)
    errMsg("Invalid leave scope");
} 

string itoa(int i) {
  char b[64];
  sprintf(b, "%d", i);
  return string(b);
}

void checkStateMachine(const string& s) {
  const ModuleEntry* ste = 
	(const ModuleEntry*)stm.currentScope(MODULE_KIND);
  if ((ste != NULL) && (!ste->isStateMachine()))
	errMsgLn(string("`")+s+"' is valid only within state machines");
}

string newName(string type) {
  string s("__");
  s +=type+"__"+ itoa(variableCount++);
  return s;
}

